<template>
  <q-dialog
    ref="dialog"
    @hide="$emit('hide')"
  >
    <q-card
      class="q-dialog-plugin"
      style="width: 800px; max-width: 80vw;"
    >
      <q-card-section>
        <div
          class="text-h5 text-weight-bolder text-grey-9 q-pb-sm"
          v-text="'Plano'"
        />
      </q-card-section>

      <q-form>
        <q-card-section horizontal>
          <q-card-section class="row col q-gutter-y-sm q-pt-none">
            <q-input
              v-model="form.title"
              class="col-12"
              label="Título"
              color="primary"
              bottom-slots
              outlined
              dense
              :error="$v.form.title.$error"
            >
              <template v-slot:error>
                <div
                  v-for="(message, index) in errorMessages($v.form.title)"
                  :key="index"
                  v-text="message"
                />
              </template>
            </q-input>

            <q-input
              v-model="form.subtitle"
              class="col-12"
              label="Subtítulo"
              color="primary"
              bottom-slots
              outlined
              dense
              :error="$v.form.subtitle.$error"
            >
              <template v-slot:error>
                <div
                  v-for="(message, index) in errorMessages($v.form.subtitle)"
                  :key="index"
                  v-text="message"
                />
              </template>
            </q-input>

            <q-input
              v-model="form.description"
              class="col-12"
              label="Descrição"
              color="primary"
              bottom-slots
              outlined
              dense
            />

            <q-input
              v-model="form.price"
              class="col-12"
              color="primary"
              fill-mask="0"
              label="Preço"
              mask="#,##"
              reverse-fill-mask
              bottom-slots
              outlined
              dense
              :error="$v.form.price.$error"
            >
              <template v-slot:error>
                <div
                  v-for="(message, index) in errorMessages($v.form.price)"
                  :key="index"
                  v-text="message"
                />
              </template>
            </q-input>

            <q-input
              v-model="form.installments"
              class="col-12"
              label="Parcelas"
              color="primary"
              mask="##"
              bottom-slots
              outlined
              dense
              :error="$v.form.installments.$error"
            >
              <template v-slot:error>
                <div
                  v-for="(message, index) in errorMessages($v.form.installments)"
                  :key="index"
                  v-text="message"
                />
              </template>
            </q-input>

            <q-input
              v-model="form.buttonLabel"
              class="col-12"
              label="Texto do Botão"
              color="primary"
              bottom-slots
              outlined
              dense
              :error="$v.form.buttonLabel.$error"
            >
              <template v-slot:error>
                <div
                  v-for="(message, index) in errorMessages($v.form.buttonLabel)"
                  :key="index"
                  v-text="message"
                />
              </template>
            </q-input>

            <q-input
              ref="color"
              v-model="form.color"
              class="col-12"
              label="Cor"
              color="primary"
              bottom-slots
              outlined
              dense
              :error="$v.form.color.$error"
            >
              <template v-slot:append>
                <q-icon
                  class="cursor-pointer"
                  name="las la-palette"
                >
                  <q-popup-proxy
                    ref="popupColor"
                    transition-show="scale"
                    transition-hide="scale"
                    :target="$refs.color"
                    @hide="$refs.benefitIcon.focus()"
                  >
                    <q-color
                      v-model="form.color"
                      default-view="palette"
                      format-model="hex"
                      flat
                      @change="$refs.popupColor.hide()"
                    />
                  </q-popup-proxy>
                </q-icon>
              </template>

              <template v-slot:error>
                <div
                  v-for="(message, index) in errorMessages($v.form.color)"
                  :key="index"
                  v-text="message"
                />
              </template>
            </q-input>

            <q-toggle
              v-model="form.recommended"
              class="q-pt-sm"
              color="primary"
              label="Plano Recomendado"
              keep-color
              dense
            />
          </q-card-section>

          <q-separator vertical />

          <q-card-section class="col q-gutter-y-sm q-pt-none">
            <q-field
              label="Benefícios"
              no-error-icon
              stack-label
              outlined
              dense
              :error="$v.benefits.$error"
            >
              <template v-slot:error>
                <div
                  v-for="(message, index) in errorMessages($v.benefits)"
                  :key="index"
                  v-text="message"
                />
              </template>

              <div class="row q-gutter-y-sm q-py-sm">
                <q-input
                  ref="benefitIcon"
                  v-model="benefit.icon"
                  class="col-12"
                  label="Ícone"
                  color="primary"
                  bottom-slots
                  outlined
                  dense
                  :error="$v.benefit.icon.$error"
                >
                  <template v-slot:append>
                    <q-icon
                      class="cursor-pointer"
                      name="las la-puzzle-piece"
                    >
                      <q-popup-proxy
                        ref="benefitPopupIcon"
                        transition-show="scale"
                        transition-hide="scale"
                        :target="$refs.benefitIcon"
                        @hide="hidePopup"
                      >
                        <q-input
                          v-model="filter"
                          class="q-pa-sm"
                          placeholder="Buscar"
                          color="primary"
                          debounce="300"
                          autofocus
                          outlined
                          dense
                        >
                          <template v-slot:append>
                            <q-icon name="search" />
                          </template>
                        </q-input>

                        <q-icon-picker
                          v-model="benefit.icon"
                          style="height: 184px; width: 336px;"
                          selected-background-color="primary"
                          :pagination.sync="pagination"
                          icon-set="fontawesome-v5"
                          selected-color="white"
                          :filter="filter"
                          color="grey"
                          animated
                          @input="$refs.benefitPopupIcon.hide()"
                        />
                      </q-popup-proxy>
                    </q-icon>
                  </template>

                  <template v-slot:error>
                    <div
                      v-for="(message, index) in errorMessages($v.benefit.icon)"
                      :key="index"
                      v-text="message"
                    />
                  </template>
                </q-input>

                <q-input
                  ref="benefitLabel"
                  v-model="benefit.label"
                  class="col-12"
                  label="Texto"
                  color="primary"
                  bottom-slots
                  outlined
                  dense
                  :error="$v.benefit.label.$error"
                  @keyup.enter="add(benefit)"
                >
                  <template v-slot:error>
                    <div
                      v-for="(message, index) in errorMessages($v.benefit.label)"
                      :key="index"
                      v-text="message"
                    />
                  </template>
                </q-input>

                <q-btn
                  class="full-width q-mb-xs"
                  :label="benefitIndex !== null ? 'Alterar' : 'Adicionar'"
                  color="primary"
                  unelevated
                  @click="add(benefit)"
                />
              </div>
            </q-field>

            <q-scroll-area
              class="col-12"
              style="height: 270px"
            >
              <q-list
                class="rounded-borders"
                :style="listStyle"
                separator
                bordered
              >
                <q-icon
                  v-if="!benefits.length"
                  class="absolute-center"
                  name="far fa-folder-open"
                  color="grey-4"
                  size="150px"
                />

                <q-item
                  v-for="(item, index) in benefits"
                  :key="index"
                  class="q-pr-xs"
                  dense
                >
                  <q-item-section side>
                    <q-icon
                      :name="item.icon"
                      size="18px"
                    />
                  </q-item-section>

                  <q-item-section>
                    <div
                      class="text-grey-8"
                      v-text="item.label"
                    />
                  </q-item-section>

                  <q-item-section
                    class="no-padding"
                    side
                  >
                    <q-btn
                      icon="fas fa-edit"
                      color="primary"
                      size="sm"
                      round
                      dense
                      flat
                      @click="edit(item)"
                    >
                      <q-tooltip
                        content-class="text-caption text-bold bg-primary super-rounded-borders q-py-none"
                        transition-show="fade"
                        transition-hide="fade"
                        anchor="center left"
                        self="center right"
                      >
                        <div v-text="'Editar'" />
                      </q-tooltip>
                    </q-btn>
                  </q-item-section>

                  <q-item-section
                    class="no-padding"
                    side
                  >
                    <q-btn
                      icon="fas fa-trash-alt"
                      color="negative"
                      size="sm"
                      round
                      dense
                      flat
                      @click="del(item)"
                    >
                      <q-tooltip
                        content-class="text-caption text-bold bg-primary super-rounded-borders q-py-none"
                        transition-show="fade"
                        transition-hide="fade"
                        anchor="center right"
                        self="center left"
                      >
                        <div v-text="'Remover'" />
                      </q-tooltip>
                    </q-btn>
                  </q-item-section>
                </q-item>
              </q-list>
            </q-scroll-area>
          </q-card-section>
        </q-card-section>
      </q-form>

      <q-card-actions align="right">
        <q-btn
          class="q-mr-sm q-mb-sm"
          color="primary"
          label="OK"
          @click="save"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
import { ErrorMessagesMixin } from '../../mixin/error-messages'
import { required } from 'vuelidate/lib/validators'

const hex = /^#[0-9a-fA-F]{3}([0-9a-fA-F]{3})?$/
const isHex = (val) => hex.test(val)
const factoryBenefit = JSON.stringify({ icon: '', label: '' })

export default {
  name: 'FormPlan',
  mixins: [ErrorMessagesMixin],
  props: {
    value: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      form: this.value,
      benefit: JSON.parse(factoryBenefit),
      benefits: Object.assign([], this.value.benefits),
      pagination: {
        itemsPerPage: 24,
        page: 1
      },
      filter: '',
      benefitIndex: null
    }
  },
  validations: {
    form: {
      title: {
        required
      },
      subtitle: {
        required
      },
      price: {
        required
      },
      installments: {
        required
      },
      benefits: {
        required
      },
      buttonLabel: {
        required
      },
      color: {
        required,
        isHex
      }
    },
    benefit: {
      icon: {
        required
      },
      label: {
        required
      }
    },
    benefits: {
      required
    }
  },
  computed: {
    listStyle () {
      return {
        height: !this.benefits.length ? '270px' : undefined
      }
    }
  },
  methods: {
    show () {
      this.$refs.dialog.show()
    },
    hide () {
      this.$refs.dialog.hide()
    },
    add (benefit) {
      this.$v.benefit.$touch()

      if (this.$v.benefit.$error) {
        return undefined
      }

      if (this.benefitIndex !== null) {
        this.benefits[this.benefitIndex] = benefit
      } else {
        this.benefits.push(benefit)
      }

      this.benefit = JSON.parse(factoryBenefit)
      this.$refs.benefitIcon.focus()
      this.benefitIndex = null
      this.$v.benefit.$reset()
    },
    edit (benefit) {
      this.benefitIndex = this.benefits.indexOf(benefit)
      this.benefit = Object.assign({}, benefit)
    },
    del (benefit) {
      this.benefits.splice(this.benefits.indexOf(benefit), 1)
    },
    async save () {
      this.value.benefits = JSON.parse(JSON.stringify(this.benefits))

      this.$v.form.$touch()
      this.$v.benefits.$touch()

      if (this.$v.form.$error || this.$v.benefits.$error) {
        return undefined
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: this.form.id ? 'PATCH' : 'POST',
          url: `/Plans/${this.form.id || ''}`,
          data: JSON.parse(JSON.stringify(this.form))
        }

        axiosConfig.data.price = axiosConfig.data.price.replace(',', '.')

        await this.$axios(axiosConfig)

        this.axiosSuccess('Salvo com sucesso')
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
        this.$emit('ok')
        this.hide()
      }
    },
    hidePopup () {
      this.$refs.benefitLabel.focus()
      this.filter = ''
    }
  }
}
</script>
